 #
 # The gMobilab driver was contributed
 # by Lucie Daubigney from Supelec Metz
 # edited by Enrico Calore from Universita' degli Studi di Milano
 #

# ---------------------------------
# Finds GTecMobiLabPlus+
# Adds library to target
# Adds include path
# ---------------------------------

IF(UNIX)
	FIND_LIBRARY(gMOBIlabplus_LIBRARY NAMES gMOBIlabplus PATHS /usr/lib /usr/local/lib)
	IF(gMOBIlabplus_LIBRARY)
		MESSAGE(STATUS "  Found GMobiLabPlusAPI...")
		MESSAGE(STATUS "    [  OK  ] Third party lib ${gMOBIlabplus_LIBRARY}")
		ADD_DEFINITIONS(-DTARGET_HAS_ThirdPartyGMobiLabPlusAPI)
		TARGET_LINK_LIBRARIES(${PROJECT_NAME}-dynamic ${gMOBIlabplus_LIBRARY} )
	ELSE(gMOBIlabplus_LIBRARY)
		MESSAGE(STATUS "  FAILED to find GMobiLabPlusAPI...")
	ENDIF(gMOBIlabplus_LIBRARY)
ENDIF(UNIX)

IF(WIN32)
        FIND_PATH(PATH_gMOBIlabplusAPI gMOBIlabplus.h PATHS "C:/Program Files/gtec/gMOBIlabCAPI/PC/lib" "C:/gtec/gMOBIlabCAPI/PC/Lib" "D:/gtec/gMOBIlabCAPI/PC/Lib"  $ENV{OpenViBE_dependencies})
        IF(PATH_gMOBIlabplusAPI) 
                MESSAGE(STATUS "  Found gMOBIlab+ API directory...")
                INCLUDE_DIRECTORIES(${PATH_gMOBIlabplusAPI})
                FIND_LIBRARY(LIB_gMOBIlabplusAPI NAMES gMOBIlabplus PATHS ${PATH_gMOBIlabplusAPI} )
                IF(LIB_gMOBIlabplusAPI)
                        MESSAGE(STATUS "    [  OK  ] Third party lib ${LIB_gMOBIlabplusAPI}")
						ADD_LIBRARY(gMOBIlabplus UNKNOWN IMPORTED)
						SET_PROPERTY(TARGET gMOBIlabplus PROPERTY IMPORTED_LOCATION "${LIB_gMOBIlabplusAPI}")
                        TARGET_LINK_LIBRARIES(${PROJECT_NAME}-dynamic ${LIB_gMOBIlabplusAPI})
						ADD_DEFINITIONS(-DTARGET_HAS_ThirdPartyGMobiLabPlusAPI)
                ELSE(LIB_gMOBIlabplusAPI)
                        MESSAGE(STATUS "    [FAILED] lib gMOBIlab+ API")
                ENDIF(LIB_gMOBIlabplusAPI)
        ELSE(PATH_gMOBIlabplusAPI)
                MESSAGE(STATUS "  FAILED to find gMOBIlab+ API - cmake looked in 'C:/Program Files/gtec/gMOBIlabCAPI/PC/lib' and 'C:/gtec/gMOBIlabCAPI/PC/Lib'")
        ENDIF(PATH_gMOBIlabplusAPI)
ENDIF(WIN32)