/**
 * The gMobilab driver was contributed by:
 * GNU/Linux version by Lucie Daubigney from Supelec Metz
 * Windows version by Andrea Villa from Universita' degli Studi di Milano
 * GNU/Linux - Windows drivers integration and revision by Enrico Calore from Universita' degli studi di Milano
 * Developed thanks to the support of g.tec medical engineering GmbH, Austria
 */

#include "ovasCConfigurationGTecGMobiLabPlus.h"

#if defined TARGET_HAS_ThirdPartyGMobiLabPlusAPI

#define boolean OpenViBE::boolean

using namespace OpenViBEAcquisitionServer;
using namespace OpenViBE;
using namespace OpenViBE::Kernel;
using namespace std;

CConfigurationGTecGMobiLabPlus::CConfigurationGTecGMobiLabPlus(const char* sGtkBuilderFileName, OpenViBE::uint32& rUSBIndex, bool& rSetTestmode)
	:CConfigurationBuilder(sGtkBuilderFileName)
	,m_rUSBIndex(rUSBIndex)
	,m_rSetTestmode(rSetTestmode)
{
	m_pListStore=gtk_list_store_new(1, G_TYPE_STRING);
}

CConfigurationGTecGMobiLabPlus::~CConfigurationGTecGMobiLabPlus(void)
{
	g_object_unref(m_pListStore);
}

boolean CConfigurationGTecGMobiLabPlus::preConfigure(void)
{
	if(!CConfigurationBuilder::preConfigure())
	{
		return false;
	}

	::GtkToggleButton* l_pCheckbuttonTestmode = GTK_TOGGLE_BUTTON(gtk_builder_get_object(m_pBuilderConfigureInterface, "checkbutton_testmode"));
	gtk_toggle_button_set_active(l_pCheckbuttonTestmode,m_rSetTestmode);
	
	::GtkComboBox* l_pComboBox=GTK_COMBO_BOX(gtk_builder_get_object(m_pBuilderConfigureInterface, "combobox_device"));

	g_object_unref(m_pListStore);
	m_pListStore=gtk_list_store_new(1, G_TYPE_STRING);

	gtk_combo_box_set_model(l_pComboBox, GTK_TREE_MODEL(m_pListStore));

	char l_sBuffer[1024];
	boolean l_bSelected=false;

	for(uint32 i=1; i<17; i++)
	{
#if defined OVAS_OS_Windows
		::sprintf(l_sBuffer, "COM%i", i);
#elif defined OVAS_OS_Linux
		if(i<10)
		{
			::sprintf(l_sBuffer, i<10?"/dev/rfcomm%d":"/dev/rfcomm%d", i);
		}
		else
		{
			::sprintf(l_sBuffer, "/dev/rfcomm%d", i-10);
		}
#else
		::sprintf(l_sBuffer, "");
#endif
		::gtk_combo_box_append_text(l_pComboBox, l_sBuffer);
		if(m_rUSBIndex==i)
		{
			::gtk_combo_box_set_active(l_pComboBox, i-1);
			l_bSelected=true;
		}
	}

	if(!l_bSelected)
	{
		::gtk_combo_box_set_active(l_pComboBox, 0);
	}

	return true;
}

boolean CConfigurationGTecGMobiLabPlus::postConfigure(void)
{
	::GtkComboBox* l_pComboBox=GTK_COMBO_BOX(gtk_builder_get_object(m_pBuilderConfigureInterface, "combobox_device"));
	
	if(m_bApplyConfiguration)
	{
	
		::GtkToggleButton* l_pCheckbuttonTestmode = GTK_TOGGLE_BUTTON(gtk_builder_get_object(m_pBuilderConfigureInterface, "checkbutton_testmode"));
	    m_rSetTestmode = ::gtk_toggle_button_get_active(l_pCheckbuttonTestmode);
	
		int l_iUSBIndex=gtk_combo_box_get_active(l_pComboBox);
		if(l_iUSBIndex>=0)
		{
			m_rUSBIndex=(uint32)l_iUSBIndex+1;
		}
		m_oPortName=::gtk_combo_box_get_active_text(l_pComboBox);
		
	}

	if(!CConfigurationBuilder::postConfigure())
	{
		return false;
	}
	return true;
}

std::string CConfigurationGTecGMobiLabPlus::getPortName(void)
{
  return m_oPortName;
}

#endif // TARGET_HAS_ThirdPartyGMobiLabPlusAPI
