/**
 * The gMobilab driver was contributed by:
 * GNU/Linux version by Lucie Daubigney from Supelec Metz
 * Windows version by Andrea Villa from Universita' degli Studi di Milano
 * GNU/Linux - Windows drivers integration and revision by Enrico Calore from Universita' degli studi di Milano
 * Developed thanks to the support of g.tec medical engineering GmbH, Austria
 */


#ifndef __OpenViBE_AcquisitionServer_ovasCConfigurationGTecGMobiLabPlus_H__
#define __OpenViBE_AcquisitionServer_ovasCConfigurationGTecGMobiLabPlus_H__

#if defined TARGET_HAS_ThirdPartyGMobiLabPlusAPI

#include "../ovasCConfigurationBuilder.h"
#include "../ovasIDriver.h"
#include "../ovasCHeader.h"

#include <gtk/gtk.h>

#if defined OVAS_OS_Windows
  #include <windows.h>
#endif

namespace OpenViBEAcquisitionServer
{
	class CConfigurationGTecGMobiLabPlus : public OpenViBEAcquisitionServer::CConfigurationBuilder
	{
	public:
		CConfigurationGTecGMobiLabPlus(const char* sGtkBuilderFileName, OpenViBE::uint32& rUSBIndex, OpenViBE::boolean& rSetTestmode);
		virtual ~CConfigurationGTecGMobiLabPlus(void);

		virtual OpenViBE::boolean preConfigure(void);
		virtual OpenViBE::boolean postConfigure(void);
		std::string getPortName(void);
		bool getTestmodeStatus(void);

	protected:
		OpenViBE::uint32& m_rUSBIndex;
		OpenViBE::boolean& m_rSetTestmode;
		::GtkListStore* m_pListStore;
		std::string m_oPortName;
	};
};

#endif // TARGET_HAS_ThirdPartyGMobiLabPlusAPI

#endif
